Keywords

These keywords were added by machine and not by the authors. This process is experimental and the keywords may be updated as the learning algorithm improves.

1 Introduction

We consider topological graph drawings, which are drawings of simple undirected graphs where vertices are represented by points in the plane, and edges are represented by simple curves that connect the corresponding points. We typically restrict those drawings to satisfy some natural nondegeneracy conditions. In particular, we consider simple drawings, in which every pair of edges intersect at most once. A common vertex counts as an intersection.

While being perhaps the most natural and the most used representations of graphs, simple drawings are far from being understood from the combinatorial point of view. For the smallest number of edge crossings in a simple topological drawing of \(K_n\) [1, 2, 8] or of \(K_{k,n}\) [4, 12] there are long standing conjectures but the actual minimum remains unknown.

In order to cope with the inherent complexity of the drawings, it is useful to consider combinatorial abstractions. Those abstractions are discrete structures encoding some features of a drawing. One such abstraction, introduced by Kratochvíl, Lubiw, and Nešetřil, is called abstract topological graphs (AT-graph) [9]. An AT-graph consists of a graph (VE) together with a set \(\mathcal{X}\subseteq {E\atopwithdelims ()2}\). A topological drawing is said to realize an AT-graph if the pairs of edges that cross are exactly those in \(\mathcal X\). Another abstraction of a topological drawing is called the rotation system. The rotation system associates a circular permutation with every vertex v, which in a realization must correspond to the order in which the neighbors of v are connected to v. Natural realizability problems are: given an AT-graph or a rotation system, is it realizable as a topological drawing? The realizability problem for AT-graphs is known to be NP-complete [10].

For simple topological drawings of complete graphs, the two abstractions are actually equivalent [11]. It is possible to reconstruct the set of crossing pairs of edges by looking at the rotation system, and vice-versa. Kynčl recently proved the remarkable result that a complete AT-graph (an AT-graph for which the underlying graph is complete) can be realized as a simple topological drawing of \(K_n\) if and only if all the AT-subgraphs on at most 6 vertices are realizable [5, 6]. This directly yields a polynomial-time algorithm for the realizability problem. While this provides a key insight on topological drawings of complete graphs, similar realizability problems already appear much more difficult when they involve complete bipartite graphs. In that case, knowing the rotation system is not sufficient for reconstructing the intersecting pairs of edges.

We propose a fine-grained analysis of simple topological drawings of complete bipartite graphs. In order to make the analysis more tractable, we introduce a natural restriction on the drawings, by requiring that one side of the vertex set bipartition lies on a circle at infinity. This gives rise to meaningful, yet complex enough, combinatorial structures.

Definitions. We wish to draw the complete bipartite graph \(K_{k,n}\) in the plane in such a way that:

  1. 1.

    vertices are represented by points,

  2. 2.

    edges are continuous curves that connect those points, and do not contain any other vertices than their two endpoints,

  3. 3.

    no more than two edges intersect in one point,

  4. 4.

    edges pairwise intersect at most once; in particular, edges incident to the same vertex intersect only at this vertex,

  5. 5.

    the k vertices of one side of the bipartition lie on the outer boundary of the drawing.

Properties 1–4 are the usual requirements for simple topological drawings also known as good drawings. As we will see, property 5 leads to drawings with interesting combinatorial structures. Throughout this paper, the term drawing always refers to drawings satisfying the above properties.

The set of vertices of a bipartite graph \(K_{k,n}\) will be denoted by \(P\cup V\), where P and V are the two sides of the bipartition, with \(|P|=k\) and \(|V|=n\). When we consider a given drawing, we will use the word “vertex” and “edge” to denote both the vertex or edge of the graph, and their representation as points and curves. Without loss of generality, we can assume that the k outer vertices \(p_1,\ldots ,p_k\) lie in clockwise order on the boundary of a disk that contains all the edges, or on the line at infinity. The vertices of V are labeled \(1,\ldots ,n\). An example of such a drawing is given in Fig. 1.

Fig. 1.
figure 1

Two drawings of \(K_{3,5}\) satisfying the constraints. In both drawings the rotation system is (12345, 21435, 13254).

The rotation system of the drawing is a sequence of k permutations on n elements associated with the vertices of P in clockwise order. For each vertex of P, its permutation encodes the (say) counterclockwise order in which the n vertices of V are connected to it. Due to our last constraint on the drawings, the rotations of the k vertices of P around each vertex of V are fixed and identical, they reflect the clockwise order of \(p_1,\ldots ,p_k\) on the boundary.

Unlike for complete graphs, the rotation system of a drawing of a complete bipartite graph does not completely determine which pairs of edges are intersecting. This is exemplified with the two drawings in Fig. 1.

Results. The paper is organized as follows. In Sect. 2, we consider drawings with a uniform rotation system, in which the k permutations of the vertices of P are all equal to the identity. In this case, we can state a general structure theorem that allows us to completely characterize and count drawings of arbitrary bipartite graphs \(K_{k,n}\).

In Sect. 3, we consider drawings of \(K_{2,n}\) with arbitrary rotation systems. We consider a natural combinatorial encoding of such drawings, and state two necessary consistency conditions involving triples and quadruples of points in V. We show that these conditions are also sufficient, yielding a polynomial-time algorithm for checking consistency of a drawing.

In Sect. 4, we consider drawings of \(K_{3,n}\) and study a complete classification of all drawings of \(K_{3,3}\). This directly gives a necessary consistency condition on triples of vertices in V. We also provide an additional necessary condition on quadruples. A proof that the consistency conditions on triples and quadruples are sufficient for drawings of \(K_{3,n}\) can be found in the long version of the paper [3].

2 Drawings with Uniform Rotation System

We first consider the case where k is arbitrary but the rotation system is uniform, that is, the permutation around each of the k vertices \(p_i\) is the same. Without loss of generality we assume that this permutation is the identity permutation on [n].

In a given drawing, each of the n vertices of V splits the plane into k regions \(Q_1, Q_2, \ldots ,Q_k\), where each \(Q_i\) is bounded by the edges from v to \(p_i\) and \(p_{i+1}\), with the understanding that \(p_{k+1}=p_1\). We denote by \(Q_i(v)\) the ith region defined by vertex v and further on call these regions quadrants. We let \({{\mathrm{type}}}(a,b) = i\), for \(a,b\in V\) and \(i\in [k]\), whenever \(a\in Q_i(b)\). This implies that \(b\in Q_i(a)\), see Fig. 2. Indeed if \(a<b\) and \(j\ne i+1\), then edge \(p_{i+1}b\) has to intersect all the edges \(p_ja\), while edge \(p_jb\) has to avoid \(p_{i+1}b\) until they meet in b. It follows that none of the edges \(p_jb\) can intersect \(p_{i+1}a\). This shows that \(a \in Q_i(b)\).

Fig. 2.
figure 2

Having placed b in \(Q_4(a)\) the crossing pairs of edges and the order of crossings on each edge is prescribed. In particular \(a\in Q_4(b)\). On the right a symmetric drawing of the pair.

Observation 1

(Symmetry). For all a, b in uniform rotation systems:   \({{\mathrm{type}}}(a,b) = {{\mathrm{type}}}(b,a).\)

For the case \(k=2\), we have exactly two types of pairs, that we will denote by A and B. The two types are illustrated on Fig. 3.

The drawings of \(K_{2,n}\) with uniform rotations can be viewed as colored pseudoline arrangements, where each pseudoline is split into two segments of distinct colors, and no crossing is monochromatic. This is illustrated on Fig. 4. The pseudoline of a vertex \(v\in V\) is denoted by \(\ell (v)\). The left (red) and right (blue) parts of this pseudoline are denoted by \(\ell _L (v)\) and \(\ell _R(v)\). Now having \({{\mathrm{type}}}(a,b) = {{\mathrm{type}}}(b,a) = A\) means that b lies above \(\ell (a)\) and a lies above \(\ell (b)\). While having \({{\mathrm{type}}}(a,b) = {{\mathrm{type}}}(b,a) = B\) means that b lies below \(\ell (a)\) and a lies below \(\ell (b)\).

Fig. 3.
figure 3

The two types of pairs for drawings of \(K_{2,n}\) with uniform rotation systems. (Color figure online)

Fig. 4.
figure 4

Drawing \(K_{2,4}\) as a colored pseudoline arrangement. The type of each pair is given in the table on the right. (Color figure online)

The Triple Rule.

Lemma 1

(Triple rule). For uniform rotation systems and three vertices \(a,b,c\in V\) with \(a<b<c\)

$$ {{\mathrm{type}}}(a,c)\in \{ {{\mathrm{type}}}(a,b), type (b,c) \}.$$

Proof

Case \(k=2\). If \({{\mathrm{type}}}(a,b) \ne {{\mathrm{type}}}(b,c)\) there is nothing to show since there are only two types. Without loss of generality, suppose that \({{\mathrm{type}}}(a,b)={{\mathrm{type}}}(b,c)=B\). This situation is illustrated in the left part of Fig. 5. The pseudoline \(\ell (c)\) must cross \(\ell (b)\) on \(\ell _R(b)\), otherwise we would have \({{\mathrm{type}}}(b,c)=A\). Hence the point c is on the right of this intersection. Pseudoline \(\ell (a)\) must cross \(\ell (b)\) on \(\ell _L(b)\), and a is left of this intersection. It follows that \(\ell (a)\) and \(\ell (c)\) cross on \(\ell _R(a)\) and \(\ell _L(c)\), i.e., \({{\mathrm{type}}}(a,c)=B\).

Case \(k>2\). For the general case assume that \({{\mathrm{type}}}(a,b)= i\) and \({{\mathrm{type}}}(a,c) = j\). If \(i=j\) there is nothing to show. Now suppose \(i\ne j\). From \(c\in Q_j(a)\) it follows that \(p_{j+1}a\) and \(p_jc\) are disjoint. Edges \(p_jb\) and \(p_jc\) only share the endpoint \(p_j\), hence c has to be in the region delimited by \(p_jb\) and \(p_{j+1}a\), see the right part of Fig. 5. This region is contained in \(Q_j(b)\), hence \({{\mathrm{type}}}(b,c) = j\).    \(\square \)

Fig. 5.
figure 5

Illustrations for the \(k=2\) case of Lemma 1 (left), and the \(k>2\) case of Lemma 1 (right).

The Quadruple Rule

Lemma 2

For four vertices \(a,b,c,d\in V\) with \(a<b<c<d\) and \(X\in \{A,B\}\):

if \(\;{{\mathrm{type}}}(a,c) = {{\mathrm{type}}}(b,c) = {{\mathrm{type}}}(b,d) = X\) then \({{\mathrm{type}}}(a,d) = X\).

Proof

Case \(k=2\). Suppose, without loss of generality, that \(X=B\). Consider the pseudolines representing b and c with their crossing at \(\ell _R(b)\cap \ell _L(c)\). Coming from the left the edge \(\ell _L(d)\) has to avoid \(\ell _L(c)\) and therefore intersects \(\ell _R(b)\). On \(\ell _R(b)\) the crossing with \(\ell _L(c)\) is left of the crossing with \(\ell _L(d)\), see Fig. 6. Symmetrically from the right the edge \(\ell _R(a)\) has to intersect \(\ell _L(c)\) and this intersection is left of \(\ell _R(b)\cap \ell _L(c)\). To reach the crossings with \(\ell _L(c)\) and \(\ell _R(b)\) edges \(\ell _R(a)\) and \(\ell _L(d)\) have to intersect, hence, \({{\mathrm{type}}}(a,d)=B\).

Fig. 6.
figure 6

Illustration for the \(k>2\) case of Lemma 1.

Case \(k>2\). In the general case, we let \(X=i\), and consider the pseudoline arrangement defined by the two successive vertices \(p_i\) and \(p_{i+1}\) of P defining the quadrants \(Q_i\). Proving that \({{\mathrm{type}}}(a,d)=i\), that is, that \(a\in Q_i(d)\), can be done as above for \(k=2\) on the drawing of \(K_{2,n}\) induced by \(\{p_i, p_{i+1}\}\) and V.    \(\square \)

Decomposability and Counting

We can now state a general structure theorem for all drawings of \(K_{k,n}\) with uniform rotation systems.

Theorem 1

Given a type for each pair of vertices in V, there exists a drawing realizing those types if and only if:

  1. 1.

    there exists \(s\in \{2,\ldots ,n\}\) and \(X\in [k]\) such that \({{\mathrm{type}}}(a,b) = X\) for all pairs ab with \(a< s\) and \(b \ge s\),

  2. 2.

    the same holds recursively when the interval [1, n] is replaced by any of the two intervals \([1,s-1]\) and [sn].

Proof

\((\Rightarrow )\) Let us first show that if there exists a drawing, then the types must satisfy the above structure. We proceed by induction on n. Pick the smallest \(s \in \{2,\ldots ,n\}\) such that \({{\mathrm{type}}}(1,b) = {{\mathrm{type}}}(1,s)\) for all \(b\ge s\). Set \(X := {{\mathrm{type}}}(1,s)\). We claim that \({{\mathrm{type}}}(a,b)=X\) for all ab such that \(1\le a<s\le b\le n\). For \(a=1\) this is just the condition on s. Now let \(1<a\).

First suppose that \({{\mathrm{type}}}(1,a)\not = X\). We can apply the triple rule on 1, ab. Since \({{\mathrm{type}}}(1,b)\in \{{{\mathrm{type}}}(1,a),{{\mathrm{type}}}(a,b)\}\), we must have that \({{\mathrm{type}}}(a,b)=X\).

Now suppose that \({{\mathrm{type}}}(1,a)=X\). We have \({{\mathrm{type}}}(1,s-1) = Y \not = X\) by definition. As in the previous case we obtain \({{\mathrm{type}}}(s-1, b)=X\) from the triple rule for \(1,s-1,b\). Applying the triple rule on \(1,a,s-1\) yields \({{\mathrm{type}}}(a,s-1)=Y\).

Now apply the quadruple rule on \(1,a,s-1,b\). We know that \({{\mathrm{type}}}(1,s-1)={{\mathrm{type}}}(a,s-1)=Y\), and by definition \({{\mathrm{type}}}(1,b)=X\). Hence we must have that \({{\mathrm{type}}}(a,b)\not = Y\).

Finally, apply the triple rule on \(a,s-1,b\). We know that \({{\mathrm{type}}}(a,s-1)=Y\), \({{\mathrm{type}}}(s-1,b)=X\). Since \({{\mathrm{type}}}(a,b)\not = Y\), we must have \({{\mathrm{type}}}(a,b)=X\). This yields the claim.

\((\Leftarrow )\) Now given the recursive structure, it is not difficult to construct a drawing. Consider the two subintervals as a single vertex, then recursively blow up these two vertices. (See Fig. 7 for an illustration).    \(\square \)

The recursive structure yields a corollary on the number of distinct drawings.

Corollary 1

(Counting drawings with uniform rotation systems). For every pair of integers \(k,n>0\) denote by T(kn) the number of simple topological drawings of the complete bipartite graph isomorphic to \(K_{k,n}\) with uniform rotation systems. Then

$$ T(n+1, k+1) = \sum _{j=0}^{n} \genfrac(){0.0pt}1{n+j}{2j}\,C_j\,k^j $$

where \(C_j\) is the jth Catalan number.

Fig. 7.
figure 7

Illustration of the recursive structure of the drawings in the uniform case.

3 Drawings with \(k=2\)

In this section we deal with drawings with \(k=2\) and arbitrary rotation system. We now have three types of pairs, that we call N, A, and B, as illustrated on Fig. 8. The type N (for noncrossing) is new, and is forced whenever the pair corresponds to an inversion in the two permutations.

Fig. 8.
figure 8

The three types of pairs for drawings of \(K_{2,n}\) with arbitrary rotation systems.

Recall that a drawing of \(K_{2,n}\), in which no pair is of type N, can be seen as a colored pseudoline arrangement as defined previously. Similarly, a drawing of \(K_{2,n}\) in which some pairs are of type N can be seen as an arrangement of colored monotone curves crossing pairwise at most once. We will refer to arrangement of monotone curves that cross at most once as quasi-pseudoline arrangements. The pairs of type N correspond to parallel pseudolines. Without loss of generality, we can suppose that the first permutation in the rotation system, that is, the order of the pseudolines on the left side, is the identity. We denote by \(\pi \) the permutation on the right side.

Note that every permutation \(\pi \) is feasible in the sense that there is a drawing of \(K_{2,n}\) such that the rotations are \(({{\mathrm{id}}},\pi )\). To realize this, take the point set \(\{ (i,\pi (i)):i\in [n]\}\) and consider horizontal and rays starting from each of these points to the left and upward respectively.

Triples. For \(a,b,c\in V\), with \(a<b<c\), we are interested in the triples of types \(({{\mathrm{type}}}(a,b)\), \({{\mathrm{type}}}(a,c)\), \({{\mathrm{type}}}(b,c))\) that are possible in a topological drawing of \(K_{2,n}\), i.e., all possible topological drawings of \(K_{2,3}\). Such triples will be called legal. We like to display triples in little tables, e.g., the triple \({{\mathrm{type}}}(a,b)=X\), \({{\mathrm{type}}}(a,c)=Y\), and \({{\mathrm{type}}}(b,c)=Z\) is represented as

Lemma 3

(Decomposable Triples Footnote 1 ). A triple with \(Y \in \{X,Z\}\) is always legal. There are 15 triples of this kind.

Lemma 4

There are exactly two non-decomposable legal triples: and .

The proofs of the two lemmas can be found in [3]. With the two lemmas we have classified all 17 legal triples.

Observation 2

(Triple Rule). Any three vertices of V in a drawing of \(K_{2,n}\) must induce one of the 17 legal triples of types.

Quadruples. We aim at a characterization of collections of types that correspond to drawings. Already in the case of uniform rotations we had to add Lemma 2, a condition for quadruples. In the general case the situation is more complex than in the uniform case, see Fig. 9.

Fig. 9.
figure 9

The quadruple rule from Lemma 2 does not hold in the presence of N types.

Reviewing the proof of Lemma 2 we see that in the case discussed there, where given B types are intended to enforce \({{\mathrm{type}}}(a,d)=B\), we need that in \(\pi \) element a is before b, this is equivalent to \({{\mathrm{type}}}(a,b)\ne N\). Symmetrically, three A types enforce \({{\mathrm{type}}}(a,d)=A\) when d is the last in \(\pi \), i.e., if \({{\mathrm{type}}}(c,d)\ne N\).

Lemma 5

Consider four vertices \(a,b,c,d\in V\) such that \(a<b<c<d\).

If \({{\mathrm{type}}}(a,b)\ne N\) and \({{\mathrm{type}}}(a,c)\! =\! {{\mathrm{type}}}(b,c)\! =\! {{\mathrm{type}}}(b,d)\! = B\) then \({{\mathrm{type}}}(a,d) = B\).

If \({{\mathrm{type}}}(c,d)\ne N\) and \({{\mathrm{type}}}(a,c)\! =\! {{\mathrm{type}}}(b,c)\! =\! {{\mathrm{type}}}(b,d)\! = A\) then \({{\mathrm{type}}}(a,d) = A\).

Consistency. With the next theorem we show that consistency on triples and quadruples is enough to grant the existence of a drawing.

Theorem 2

(Consistency of drawings for \(k=2\) ). Given a type for each pair of vertices in V, there exists a drawing realizing those types if and only if all triples are legal and the quadruple rule (Lemma 5) is satisfied.

The proof of this result is based on the characterization of local sequences in pseudoline arrangements. Given an arrangement of n pseudolines, the local sequences are the permutations \(\alpha _i\) of \([n]\setminus \{ i\}\), \(i\in [n]\), representing the order in which the ith pseudoline intersects the \(n-1\) others.

Lemma 6

(Theorem 6.17 in [7]). The set \(\{ \alpha _i\}_{i\in [n]}\) is the set of local sequences of an arrangement of n pseudolines if and only if

$$ ij \in {{\mathrm{inv}}}(\alpha _k) \Leftrightarrow ik \in {{\mathrm{inv}}}(\alpha _j) \Leftrightarrow jk \in {{\mathrm{inv}}}(\alpha _i), $$

for all triples ijk, where \({{\mathrm{inv}}}(\alpha )\) is the set of inversions of the permutation \(\alpha \).

Proof

(Theorem 2 ). The necessity of the condition is implied by Observation 2 and Lemma 5.

We proceed by giving an algorithm for constructing an appropriate drawing. From the proof of Lemma 4, we know that having legal triples implies that the sets of inversion pairs and its complement, the set of non-inversion pairs, are both transitive. Hence, there is a well defined permutation \(\pi \) representing the rotation at \(p_2\).

We aim at defining the local sequences \(\alpha _i\) that allow an application of Lemma 6. This will yield a pseudoline arrangement. A drawing of \(K_{2,n}\), however, will only correspond to a quasi-pseudoline arrangement. Therefore, we first construct a quasi-pseudoline arrangement T for the pair \((\overline{\pi },{{\mathrm{id}}})\), i.e., only the quasi-pseudolines corresponding to i and j with \({{\mathrm{type}}}(i,j)=N\) cross in T. The idea is that appending T on the right side of the quasi-pseudoline arrangement of the drawing yields a full pseudoline arrangement.

Now fix \(i\in [n]\). Depending on i we partition the set \([n]\setminus i\) into five parts. For a type X let \(X_<(i) = \{ j : j < i \text { and } {{\mathrm{type}}}(j,i) = X \}\) and \(X_>(i) = \{ j : j > i \text { and } {{\mathrm{type}}}(i,j) = X \}\), the five relevant parts are \(A_<(i)\), \(A_>(i)\), \(B_<(i)\), \(B_>(i)\), and \(N(i) = N_<(i) \cup N_>(i)\). The pseudoline \(\ell _i\) has three parts. The edge incident to \(p_1\) (the red edge) is crossed by pseudolines \(\ell _j\) with \(j \in A_>(i) \cup B_<(i)\). The edge incident to \(p_2\) (the blue edge) is crossed by pseudolines \(\ell _j\) with \(j \in A_<(i) \cup B_>(i)\). The part of \(\ell _i\) belonging to T is crossed by pseudolines \(\ell _j\) with \(j \in N(i)\). The order of the crossings in the third part, i.e., the order of crossings with pseudolines \(\ell _j\) with \(j\in N(i)\), is prescribed by T.

Regarding the order of the crossings on the second part we know that the lines for \(j\in A_<(i)\) have to cross \(\ell _i\) from left to right in order of decreasing indices and the lines for \(j\in B_>(i)\) have to cross \(\ell _i\) from left to right in order of increasing indices, see Fig. 10. If \(j\in A_<(i)\) and \(j'\in B_>(i)\), then consistency of triples implies that \({{\mathrm{type}}}(j,j') \in \{A,B\}\). If \({{\mathrm{type}}}(j,j')=A\), then on \(\ell _i\) the crossing of \(j'\) has to be left of the crossing of j. If \({{\mathrm{type}}}(j,j')=B\), then on \(\ell _i\) the crossing of j has to be left of the crossing of \(j'\).

Fig. 10.
figure 10

Crossings on the edge \(i\,p_2\).

The described conditions yield a “left–to–right” relation \(\rightarrow _i\) such that for all \(x,y\in A_<(i) \cup B_>(i)\) one of \(x\rightarrow _i y\) and \(y\rightarrow _i x\) holds. We have to show that \(\rightarrow _i\) is acyclic. Since \(\rightarrow _i\) is a tournament it is enough to show that \(\rightarrow _i\) is transitive.

Suppose there is a cycle \(x\rightarrow _i y\rightarrow _i z\rightarrow _i x\). If \(x,y < i\) and \(z > i\), then \({{\mathrm{type}}}(x,i)={{\mathrm{type}}}(y,i) = A\), moreover, from \(x\rightarrow _i y\) we get \(y < x\) and from \(y\rightarrow _i z\rightarrow _i x\) we get \({{\mathrm{type}}}(x,z)= A\), and \({{\mathrm{type}}}(y,z)=B\). Since \({{\mathrm{type}}}(i,z) = B \ne N\) this is a violation of the second quadruple rule of Lemma 5.

If \(x <i\) and \(y,z >i\), then we have \({{\mathrm{type}}}(i,y)={{\mathrm{type}}}(i,z) = B\). From this together with \(y\rightarrow _i z\) we obtain \(y < z\), and \( z\rightarrow _i x \rightarrow _i y\) yields \({{\mathrm{type}}}(x,y)= B\), and \({{\mathrm{type}}}(x,z)=A\). This is a violation of the first quadruple rule of Lemma 5.

Adding the corresponding arguments for the order of crossings on the first part of line \(\ell _i\) we conclude that the permutation \(\alpha _i\) is uniquely determined by the given types and the choice of T.

The consistency condition on triples of local sequences needed for the application of Lemma 6 is trivially satisfied because legal triples of types correspond to drawings of \(K_{2,3}\) and each such drawing together with the extensions of the lines in T consists of three pairwise crossing pseudolines.    \(\square \)

Since the two rules we enforced only involve at most four vertices of V, we immediately get the following corollary.

Corollary 2

Consistency on all 4-tuples of V is sufficient and necessary for drawings of \(K_{2,n}\), yielding an \(O(n^4)\) time algorithm for checking consistency of an assignment of types.

4 Drawings with \(k=3\)

At the beginning of the previous section we have seen that any pair of rotations is feasible for drawings of \(K_{2,n}\). This is not true in the case of \(k> 2\). For \(k=4\) the system of rotations ([1, 2], [2, 1], [1, 2], [2, 1]) is easily seen to be infeasible. In the case \(k=3\) it is less obvious that infeasible systems of rotations exist. We will show later (Proposition 1) that ([1, 2, 3, 4], [4, 2, 1, 3], [2, 4, 3, 1]) is infeasible.

Fig. 11.
figure 11

The six types of drawings of \(K_{3,2}\). (Color figure online)

Pairs. We again start by looking at the types for pairs, i.e., at all possible drawings of \(K_{3,2}\). We already know that if the rotation system is uniform \(({{\mathrm{id}}}_2,{{\mathrm{id}}}_2,{{\mathrm{id}}}_2)\), then there are three types of drawings. The other three options \(({{\mathrm{id}}}_2,\overline{{{\mathrm{id}}}_2},\overline{{{\mathrm{id}}}_2})\), \(({{\mathrm{id}}}_2,\overline{{{\mathrm{id}}}_2},{{{\mathrm{id}}}_2})\), and \(({{\mathrm{id}}}_2,{{{\mathrm{id}}}_2},\overline{{{\mathrm{id}}}_2})\), each have a unique drawing. Figure 11 shows the six possible types and associates them to the symbols \(B_{\alpha }\), and \(W_{\alpha }\), for \(\alpha =1,2,3\).

The three edges emanating from a vertex \(i\in [n]\) partition the drawing area into three regions. Define \(Q_\alpha (i)\) as the region bounded by the two edges \(i\,p_{\alpha +1}\) and \(i\,p_{\alpha -1}\) not containing \(p_\alpha \) When the types have been prescribed for all pairs of vertices we know which vertices are located in which region of i. Conversely, if we know the \(\alpha \) for which \(j\in Q_\alpha (i)\), then only one B-type and one W-type remain eligible for the pair (ij).

Triples. We now classify the triples, i.e., drawings of \(K_{3,3}\). It turns out that there are 92 types. A complete description can be found in [3].

Now suppose that rotations \(({{\mathrm{id}}},\pi _2,\pi _3)\) are prescribed. We want to decide whether there is a corresponding drawing. The first step would be to determine the type of the drawing for each pair of vertices. For all non-uniform pairs \({{\mathrm{type}}}(i,j) \in \{W_{1},W_{2},W_{3}\}\) is uniquely given by the system.

The type of the remaining pairs is \(B_{\alpha }\) for some \(\alpha \). Beforehand each \(\alpha \in \{1, 2, 3\}\) is possible but of course the types of every triple must also correspond to a drawing, i.e., the types of each triple must be among the 89 drawable types of the classification. This may force the types of additional pairs.

Before giving a larger example we show that by looking at triples we can deduce that not all choices \(({{\mathrm{id}}},\pi _2,\pi _3)\) of prescribed rotations are feasible, i.e., there are choices that have no corresponding drawing.

Proposition 1

The system \(({{\mathrm{id}}}_4, [4, 2, 1, 3], [2, 4, 3, 1])\) is an infeasible set of rotations.

Proof

The table of types for the given permutations is shown on the right. Consider the subtable corresponding to \(\{1,2,3\}\). From the classification of triples it follows that the only feasible one choice for \(\alpha \) is \(\alpha =2\).

figure e

The subtable of {2,3,4} again only allows a unique choice of \(\alpha \) which is \(\alpha =3\). This shows that there is no drawing for this set of rotations.    \(\square \)

Quadruples. Let us give a non-realizable example which nevertheless exhibits triple consistency. Consider for instance the types \({{\mathrm{type}}}(1,2) = {{\mathrm{type}}}(1,4) = {{\mathrm{type}}}(3,4) = B_{1}\) and \({{\mathrm{type}}}(1,3) = {{\mathrm{type}}}(2,3) = {{\mathrm{type}}}(2,4) = B_{2}\). Every triple is decomposable, i.e., we have consistency on triples, however, the full table is not decomposable. Since all the rotations/permutations are the identity, ie.e., the system is uniform we know from Theorem 1 that there is no corresponding drawing.

figure g

The need for a condition on quadruples is not restricted to tables of uniform systems. The table on the right is consistent on all triples, still it is not realizable. This can be shown by looking at the table corresponding to the green-blue \(K_{2,n}\) subgraph, which reveals a bad quadruple. Note that for the table of the green-blue \(K_{2,n}\) the elements have to be sorted according to \(\pi _{3} = (2,1,3,4)\).

Let T be an assignment of types, e.g., in form of a table. From T we know the corresponding system \((\pi _1,\pi _2,\pi _3)\) of rotations.

Definition 1

T is consistent on quadruples if for any four vertices abcd and \(i\in \{1,2,3\}\) the assignment of types from ABN induced by the restriction of \(\pi _{i-1}\) and \(\pi _{i+1}\) to abcd satisfies the condition from Lemma 5.

Note that checking the condition requires sorting abcd according to \(\pi _{i-1}\).

4.1 The Consistency Theorem

Theorem 3

(Consistency of drawings for \(k=3\), see [3]). Given a type for each pair of vertices in V, there exists a drawing realizing those types if and only if all triples and quadruples are consistent.